<template>
  <div>
    <!-- Edit Modal -->
    <b-modal
      id="modallg"
      ref="modallg"
      size="lg"
      hide-footer
      :title="
        $t('guest.edit') + ' ' + $t('guest.title') + ' : ' + guest?.guest_name
      "
    >
      <guest-form
        :guest="guest"
        @is-success="
          $refs.vuetable.refresh();
          hideModal('modallg');
        "
      >
      </guest-form>
    </b-modal>
    <!-- End Edit Modal -->

    <!-- Confirm Modal -->
    <b-modal
      id="modalbasic"
      ref="modalbasic"
      hide-footer
      :title="$t('guest.confirm-deletion')"
    >
      <p>
        {{ $t("guest.confirm-deletion-message") + " - " + guest?.guest_name }}
      </p>
      <div class="inline-btn">
        <b-button
          type="submit"
          variant="danger"
          class="mt-4"
          :disabled="submitting"
          :class="{
            'btn-multiple-state btn-shadow': true,
            'show-spinner': submitting,
            'show-success': !submitting && errorMsg === false,
            'show-fail': !submitting && errorMsg,
          }"
          @click="confirmChanges(guest?.id)"
        >
          <span class="spinner d-inline-block">
            <span class="bounce1"></span>
            <span class="bounce2"></span>
            <span class="bounce3"></span>
          </span>
          <span class="icon success">
            <i class="simple-icon-check"></i>
          </span>
          <span class="icon fail">
            <i class="simple-icon-exclamation"></i>
          </span>
          {{ $t("button.delete") }}
        </b-button>
        <b-button variant="light" class="mt-4" @click="hideModal('modalbasic')">
          {{ $t("button.cancel") }}
        </b-button>
      </div>
    </b-modal>
    <!-- End Confirm Modal -->

    <datatable-heading
      :title="$t('menu.guest')"
      :selectAll="selectAll"
      :isSelectedAll="isSelectedAll"
      :isAnyItemSelected="isAnyItemSelected"
      :keymap="keymap"
      :changePageSize="changePageSize"
      :from="from"
      :to="to"
      :total="total"
      :perPage="perPage"
    >
      <template v-slot:search>
        <div
          v-for="field in searchFields"
          :key="field.col"
          class="search-sm d-inline-block float-md-left mr-1 align-top"
        >
          <b-input
            :placeholder="$t(field.placeholder)"
            @input="(val) => searchChange(field.col, val)"
          />
        </div>
      </template>
      <template v-slot:exportBtn>
        <vue-excel-xlsx
          ref="xlsxData"
          class="btn-export"
          :data="excelData"
          :columns="excelColumns"
          :file-name="'guest-report'"
          :file-type="'xlsx'"
          :sheet-name="'Guests'"
        >
        </vue-excel-xlsx>
        <b-button
          variant="outline-primary"
          size="lg"
          class="top-right-button"
          @click="exportXlsx"
          >{{ $t("guest.export") }}</b-button
        >
      </template>
    </datatable-heading>

    <b-row>
      <b-colxx xxs="12">
        <b-card>
          <vuetable
            ref="vuetable"
            :api-url="apiBase"
            :http-options="httpOptions"
            :query-params="makeQueryParams"
            :per-page="perPage"
            :reactive-api-url="true"
            :fields="fields"
            pagination-path
            :row-class="onRowClass"
            @vuetable:pagination-data="onPaginationData"
            @vuetable:row-clicked="rowClicked"
            @vuetable:cell-rightclicked="rightClicked"
            @vuetable:load-error="handleLoadError"
          >
            <!-- <template slot="actions" slot-scope="props">
              <b-form-checkbox
                :checked="selectedItems.includes(props.rowData.id)"
                class="itemCheck mb-0"
              ></b-form-checkbox>
            </template> -->
            <template slot="actionsButtons" slot-scope="props">
              <b-button-group class="mb-2" vertical>
                <b-button
                  variant="primary default"
                  v-b-modal.modallg
                  @click="somethingModal('modallg', props.rowData.id)"
                  >{{ $t("button.edit") }}</b-button
                >
                <b-button
                  v-if="currentUser.role_id === 1"
                  variant="danger default"
                  v-b-modal.modalbasic
                  @click="somethingModal('modalbasic', props.rowData.id)"
                  >{{ $t("button.delete") }}</b-button
                >
              </b-button-group>
            </template>
          </vuetable>
        </b-card>
        <vuetable-pagination-bootstrap
          class="mt-4"
          ref="pagination"
          @vuetable-pagination:change-page="onChangePage"
        />
      </b-colxx>
    </b-row>

    <!-- Right Click Options -->
    <v-contextmenu ref="contextmenu">
      <v-contextmenu-item @click="onContextMenuAction('edit')">
        <i class="simple-icon-pencil" />
        <span>{{ $t("button.edit") }}</span>
      </v-contextmenu-item>
      <v-contextmenu-item @click="onContextMenuAction('delete')">
        <i class="simple-icon-trash" />
        <span>{{ $t("button.delete") }}</span>
      </v-contextmenu-item>
    </v-contextmenu>
  </div>
</template>
<script>
import Vuetable from "vuetable-2/src/components/Vuetable";
import VuetablePaginationBootstrap from "../../../components/Common/VuetablePaginationBootstrap";
import DatatableHeading from "../../../containers/datatable/DatatableHeading";
import GuestForm from "../../../containers/forms/Guest";
import { mapActions, mapGetters } from "vuex";
import axios from "axios";

export default {
  props: ["title"],
  components: {
    vuetable: Vuetable,
    VuetablePaginationBootstrap,
    DatatableHeading,
    GuestForm
  },
  data() {
    return {
      apiBase: process.env.VUE_APP_API_ENDPOINT + "/guest-list-pagination",
      httpOptions: {
        headers: { Authorization: "Bearer " + $cookies.get("token") },
      },
      sort: "",
      page: 1,
      perPage: 12,
      searchQuery: "",
      submitting: false,
      successMsg: "",
      errorMsg: "",
      confirmSubmit: false,
      search: {
        guest_name: "",
        email_address: "",
        contact_number: "",
        // checkpoint_one: "",
        // checkpoint_two: "",
        // checkpoint_three: "",
        // checkpoint_four: ""
      },
      searchFields: [
        { col: "guest_name", placeholder: "guest.name" },
        { col: "email_address", placeholder: "guest.email-address" },
        { col: "contact_number", placeholder: "guest.contact-number" },
        // { col: "checkpoint_one", placeholder: "guest.checkpoint-one" },
        // { col: "checkpoint_two", placeholder: "guest.checkpoint-two" },
        // { col: "checkpoint_three", placeholder: "guest.checkpoint-three" },
        // { col: "checkpoint_four", placeholder: "guest.checkpoint-four" }
      ],
      from: 0,
      to: 0,
      total: 0,
      lastPage: 0,
      phoneCode: null,
      items: [],
      selectedItems: [],
      fields: [
        // {
        //   name: "actions",
        //   title: "",
        //   titleClass: "center aligned text-left",
        //   dataClass: "center aligned text-left",
        //   width: "2%"
        // },
        {
          name: "actionsButtons",
          title: "",
          titleClass: "",
          dataClass: "",
        },
        {
          name: "guest_name",
          sortField: "guest_name",
          title: this.$t("guest.name"),
          titleClass: "",
          dataClass: "text-muted"
        },
        {
          name: "email_address",
          sortField: "email_address",
          title: this.$t("guest.email-address"),
          titleClass: "",
          dataClass: "text-muted"
        },
        {
          name: "contact_number",
          sortField: "contact_number",
          title: this.$t("guest.contact-number"),
          titleClass: "",
          dataClass: "text-muted",
          formatter: (value) => "+" + value
        },
        {
          name: "checkpoint_one",
          sortField: "checkpoint_one",
          title: this.$t("guest.checkpoint-one"),
          titleClass: "",
          dataClass: "text-muted",
          formatter: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          name: "checkpoint_two",
          sortField: "checkpoint_two",
          title: this.$t("guest.checkpoint-two"),
          titleClass: "",
          dataClass: "text-muted",
          formatter: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          name: "checkpoint_three",
          sortField: "checkpoint_three",
          title: this.$t("guest.checkpoint-three"),
          titleClass: "",
          dataClass: "text-muted",
          formatter: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          name: "checkpoint_four",
          sortField: "checkpoint_four",
          title: this.$t("guest.checkpoint-four"),
          titleClass: "",
          dataClass: "text-muted",
          formatter: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        }
      ],
      excelColumns: [
        {
          label: this.$t("guest.name"),
          field: "guest_name",
        },
        {
          label: this.$t("guest.email-address"),
          field: "email_address",
        },
        {
          label: this.$t("guest.contact-number"),
          field: "contact_number",
          dataFormat: (value) => "+" + value,
        },
        {
          label: this.$t("guest.checkpoint-one"),
          field: "checkpoint_one",
          dataFormat: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          label: this.$t("guest.checkpoint-two"),
          field: "checkpoint_two",
          dataFormat: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          label: this.$t("guest.checkpoint-three"),
          field: "checkpoint_three",
          dataFormat: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        },
        {
          label: this.$t("guest.checkpoint-four"),
          field: "checkpoint_four",
          dataFormat: (value) =>
            value === 1 ? this.$t("guest.completed") : this.$t("guest.not-completed"),
        }
      ],
      excelData: [],
    };
  },
  methods: {
    ...mapActions(["signOut", "getGuest", "deleteGuest"]),
    makeQueryParams(sortOrder, currentPage, perPage) {
      this.selectedItems = [];
      return sortOrder[0]
        ? {
            sort: sortOrder[0]
              ? sortOrder[0].field + "|" + sortOrder[0].direction
              : "",
            page: currentPage,
            per_page: this.perPage,
            search: this.searchQuery ? this.searchQuery : "",
          }
        : {
            page: currentPage,
            per_page: this.perPage,
            search: this.searchQuery ? this.searchQuery : "",
          };
    },
    onRowClass(dataItem, index) {
      if (this.selectedItems.includes(dataItem.id)) {
        return "selected";
      }
      return "";
    },

    rowClicked(dataItem) {
      const event = dataItem.event;
      const itemId = dataItem.data.id;
      if (event.shiftKey && this.selectedItems.length > 0) {
        let itemsForToggle = this.items;
        var start = this.getIndex(itemId, itemsForToggle, "id");
        var end = this.getIndex(
          this.selectedItems[this.selectedItems.length - 1],
          itemsForToggle,
          "id"
        );
        itemsForToggle = itemsForToggle.slice(
          Math.min(start, end),
          Math.max(start, end) + 1
        );
        this.selectedItems.push(
          ...itemsForToggle.map((item) => {
            return item.id;
          })
        );
        this.selectedItems = [...new Set(this.selectedItems)];
      } else {
        if (this.selectedItems.includes(itemId)) {
          this.selectedItems = this.selectedItems.filter((x) => x !== itemId);
        } else this.selectedItems.push(itemId);
      }
    },
    rightClicked(dataItem, field) {
      const event = dataItem.event;
      const itemId = dataItem.data.id;
      event.preventDefault();
      if (!this.selectedItems.includes(itemId)) {
        this.selectedItems = [itemId];
      }
      this.$refs.contextmenu.show({ top: event.pageY, left: event.pageX });
    },
    onPaginationData(paginationData) {
      this.from = paginationData.from;
      this.to = paginationData.to;
      this.total = paginationData.total;
      this.lastPage = paginationData.last_page;
      this.items = paginationData.data;
      this.$refs.pagination.setPaginationData(paginationData);
    },
    onChangePage(page) {
      this.$refs.vuetable.changePage(page);
    },

    changePageSize(perPage) {
      this.perPage = perPage;
      this.$refs.vuetable.refresh();
    },

    searchChange(col, val) {
      this.search[col] = val ? `${col}|${val}` : "";
      this.searchQuery = Object.values(this.search)
        .filter((value) => value !== "")
        .join(",");
      this.$refs.vuetable.refresh();
    },

    selectAll(isToggle) {
      if (this.selectedItems.length >= this.items.length) {
        if (isToggle) this.selectedItems = [];
      } else {
        this.selectedItems = this.items.map((x) => x.id);
      }
    },
    keymap(event) {
      switch (event.srcKey) {
        case "select":
          this.selectAll(false);
          break;
        case "undo":
          this.selectedItems = [];
          break;
      }
    },
    confirmChanges(id) {
      this.confirmSubmit = true;
      this.onDeleteGuest(id);
    },
    hideModal(refname) {
      this.$refs[refname].hide();
      if (refname === "modalbasic") {
        this.confirmSubmit = false;
      }
    },
    async somethingModal(refname, id) {
      this.$refs[refname].hide();
      await this.getGuest(id);
      if (refname === "modallg") {
        this.$refs["modallg"].show();
      }
      if (refname === "modalbasic") {
        this.$refs["modalbasic"].show();
      }
    },
    getIndex(value, arr, prop) {
      for (var i = 0; i < arr.length; i++) {
        if (arr[i][prop] === value) {
          return i;
        }
      }
      return -1;
    },

    onContextMenuAction(action) {
      switch (action) {
        case "edit": {
          this.somethingModal("modallg", this.selectedItems[0]);
          break;
        }
        case "delete": {
          this.somethingModal("modalbasic", this.selectedItems[0]);
        }
      }
    },

    handleLoadError(response) {
      if (response) {
        this.$notify("error filled", "Session Timeout", "Please login again.", {
          duration: 3000,
          permanent: false,
        });
        this.signOut();
      }
    },
    async onDeleteGuest(id) {
      if (this.confirmSubmit) {
        this.submitting = true;
        try {
          await this.deleteGuest(id);
          this.successMsg = "Guest deleted successfully";
          this.submitting = false;
          this.$notify("success filled", "Success", this.successMsg, {
            duration: 3000,
            permanent: false,
          });
          this.$refs.vuetable.refresh();
          this.hideModal("modalbasic");
        } catch (error) {
          this.submitting = false;
          this.successMsg = "";
          this.errorMsg = error.message;
          this.$notify("error filled", "Failed", this.errorMsg, {
            duration: 3000,
            permanent: false,
          });
        }
      }
    },
    async exportXlsx() {
      const response = await axios.get(
        `${process.env.VUE_APP_API_ENDPOINT}/guest-list-pagination?search=${this.searchQuery}`,
        {
          headers: { Authorization: `Bearer ${$cookies.get("token")}` },
        }
      );
      await this.excelData.push(...response.data.data);
      setTimeout(() => {
        this.$refs["xlsxData"].exportExcel();
        this.excelData = [];
      }, 200);
    },
  },
  computed: {
    ...mapGetters(["currentUser", "guest"]),
    isSelectedAll() {
      return this.selectedItems.length >= this.items.length;
    },
    isAnyItemSelected() {
      return (
        this.selectedItems.length > 0 &&
        this.selectedItems.length < this.items.length
      );
    }
  }
};
</script>

<style lang="sass" scoped>
.card-body
  // min-width: 2900px
::v-deep .icon-cards-row .card-body
  padding: 1.5rem 0.5rem
::v-deep .progress-banner
  height: 200px
  overflow: hidden
  .card-body
    i
      margin-bottom: 0
    .text-small
      font-size: 0.85rem
// hide extra spacing created by vuetable when some fields are hidden
::v-deep .vuetable-th-gutter
  display: none
</style>
